package com.offcn.api.nwn;

import io.restassured.path.json.JsonPath;
import io.restassured.response.Response;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Random;

import org.json.simple.JSONArray;

import com.offcn.TestUnti.ListUtil;
import com.offcn.TestUnti.Log;
import com.offcn.TestUnti.MapUtil;
import com.offcn.TestUnti.MySqlUtil;
import com.offcn.TestUnti.ReadProperties;
import com.offcn.TestUnti.RequestDataUtils;
import com.offcn.TestUnti.StringUtils;
import com.offcn.interfaces.API;
import com.offcn.process.NWN;
import com.offcn.process.XYZB;

import net.sf.json.JSONObject;



/**
 *账号管理-列表（有搜索功能）
 * 
 * @author puhui
 *
 */
public class getList extends NWN implements API {
	public String parameter;//参数集合
	
	public String page;//页数
	public String size;//取值大小
	
	public String username;//姓名
	public String phone;//手机号
	public String card_no;//工号
	public String status;//账户状态
	
	@Override
	public void initialize(HashMap<String, Object> data) {
	}

	@Override
	public HashMap<String, Object> handleInput(HashMap<String, Object> data) {
		// 获取parameter对应的内容
		parameter = MapUtil.getValue("parameter", data);
		card_no = MapUtil.getParameter_get(parameter, "card_no").trim();
		phone = MapUtil.getParameter_get(parameter, "phone").trim();
		username = MapUtil.getParameter_get(parameter, "username").trim();
		
		if ((!card_no.equals("")) && card_no.equals("code")) {
			card_no=ListUtil.getListValue(n_admin_card_no_List, 0);
			parameter = parameter.replace("card_no=code", "card_no="+ card_no );
		}
		if ((!phone.equals("")) && phone.equals("code")) {
			phone=ListUtil.getListValue(n_admin_phone_List, 0);
			parameter = parameter.replace("phone=code", "phone="+ phone );
		}
		if ((!username.equals("")) && username.equals("code")) {
			username=ListUtil.getListValue(n_admin_username_List, 0);
			parameter = parameter.replace("username=code", "username="+ username );
		}
		data.put("parameter", parameter);
		return data;
	}

	@Override
	public Response SendRequest(HashMap<String, Object> data, String Url,
			String Request) {
		
		Response re = RequestDataUtils.Get_one_cookie_pre(data, Url, "PHPSESSID",PHPSESSID);
		return re;
	}

	@Override
	public String handleOutput(Response re, HashMap<String, Object> data) {
		JsonPath jp = re.body().jsonPath();
		boolean result = true;
		String failReason = "";

		String json = re.asString();

		if ((data.get("statusCode") != null)
				&& (!data.get("statusCode").toString()
						.equals(String.valueOf(re.getStatusCode())))) {
			result = result && false;
			failReason = failReason + "statusCode is expected "
					+ data.get("statusCode").toString() + " but actually "
					+ String.valueOf(re.getStatusCode()) + ". ";
		}

		if (json.length() != 0) {
			
			String msg=jp.getString("message");
			String code=jp.getString("retcode");
			
			if ((data.get("code") != null ) && (code != null) && (!code.equals(data.get("code").toString()))) {
				result = result && false;
				failReason = failReason + "code is expected "
						+ data.get("code").toString() + " but actually "
						+ jp.getString("code") + ".";
			}

			if ((data.get("msg") != null) && (msg != null) && (!msg.equals(data.get("msg").toString()))) {
				result = result && false;
				failReason = failReason + "msg is expected "
						+ data.get("msg").toString() + " but actually "
						+ jp.getString("msg") + ".";
			}
			
			if(data.get("custom") != null && jp.getString("data")!=null){
				String custom=data.get("custom").toString();
				String[] ArrayString=StringUtils.getArrayString(custom,",");
//				System.out.println(jp.getString("custom"));
//				System.out.println(Arrays.toString(ArrayString));
				if(!StringUtils.VerificationString(jp.getString("data"),ArrayString)){
					result = result && false;
					failReason = failReason + "custom is expected "
							+ data.get("custom").toString() + " but actually "
							+ jp.getString("data") + ".";
				}
			}
			
			
			if("0".equals(jp.getString("retcode"))){
				parameter = MapUtil.getValue("parameter", data);
				status=MapUtil.getParameter_get(parameter,"status");
				card_no=MapUtil.getParameter_get(parameter,"card_no");
				phone=MapUtil.getParameter_get(parameter,"phone");
				username=MapUtil.getParameter_get(parameter,"username");
				
				status = MapUtil.killQuotes(status, "\"");
				card_no = MapUtil.killQuotes(card_no, "\"");
				phone = MapUtil.killQuotes(phone, "\"");
				username = MapUtil.killQuotes(username, "\"");
				
			
				status=status.length()>=1?" and status = '"+status+"'":"";
				card_no=card_no.length()>=1?" and card_no = '"+card_no+"'":"";
				phone=phone.length()>=1?" and phone = '"+phone+"'":"";
				username=username.length()>=1?" and username = '"+username+"'":"";
				
//				card_no=(status.length()>=1 && card_no.length()>=1)?" and "+card_no:card_no;
//				phone=(card_no.length()>=1 && phone.length()>=1)?" and "+phone:phone;
//				username=(phone.length()>=1 && username.length()>=1)?" and "+username:username;
				
				//是否验证数据库
				if (!isProduct) {
					
					try {
						String sql="select * from n_admin where deleted_at is null ";
						
						sql=sql+status+card_no+phone+username;
//						sql=sql2.length()>=1?sql+" where "+sql2:sql;
						
						System.out.println(sql);
						ResultSet rs_bankcard = this.sqlFromDB(sql);
						rs_bankcard.last();
						
						
						String all_num=jp.getString("all_num");
						String act_all_num=rs_bankcard.getRow()+"";
						
						if(act_all_num.equals(all_num)){
							
						}else{
							result = result && false;
							failReason = failReason + "all_num is expected "
									+ all_num + " but actually "
									+ act_all_num + ".";
						}
					} catch (Exception e) {
						result = result && false;
						failReason = failReason + "cannot verify n_admin info in DB;";
						e.printStackTrace();
					}
				}
			}
			
			
		}
		
		if (result)
			return "Pass";
		else
			return "Fail:" + failReason;
	}

}
